<?php
/*
Plugin Name: Formspring.me Updates
Plugin URI: http://marcosnobrega.com/2010/03/formspring-me-pluginwidget-para-wordpress/
Description: A sidebar widget that displays formsring.me updates
Version: 1.0.2
Author: Marcos Nóbrega
Author URI: http://marcosnobrega.com/
License: GPL

This software comes without any warranty, express or otherwise.

*/

/*
 * Question class
 * This class represents a formspring.me question
 */
class Formspring_Question{
	private $question;
	private $answer;
	private $author;
	
	public function getQuestion(){
		return $this->question;
	}
	
	public function setQuestion($question){
		$this->question = $question;
	}
	
	public function getAnswer(){
		return $this->answer;
	}
	
	public function setAnswer($answer){
		$this->answer = $answer;
	}
	
	public function getAuthor(){
		return $this->author;
	}
	
	public function setAuthor($author){
		$this->author = $author;
	}
}

function widget_FSwidget_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;
		
		
	function widget_FSwidget_getupdates($username,$number_updates){
		
		if(!($data = @file_get_contents("http://www.formspring.me/".$username))){
			return "<li>Service unavaiable.</li>";
		}

		$pattern = "/<div class=\"question\" id=\"(.*?)\">.*? <h1>(.*?)<\/h1>.*? <p>(.*?)<\/p>.*?<\/div>/si";
		
		$updates = "";
		
		if( preg_match_all($pattern,$data,$content ) ){
			foreach($content[1] as $key => $value){
				//if showed $number_updates of updates, stops
				if($number_updates && $key >= $number_updates) break;
				
				//$pos = strpos($content[2][$key],"<span");
				//$autor = $pos?substr($content[2][$key],$pos):"";
				//$content[2][$key] = $pos?substr($content[2][$key],0,$pos):$content[2][$key];
				$value = str_replace("question","",$value);
				$updates .= sprintf('<li class="formspringme-update">
					<span class="formspringme-question"><a href="http://www.formspring.me/'.$username.'/q/%s" target="_blank">%s</a></span>
					<ul><li><span class="formspringme-answer">%s</span></li></ul></li>',
				$value,
				$content[2][$key],
				//$autor,
				$content[3][$key]);
			}
		}
		
		return $updates;

	}

	function widget_FSwidget($args) {

		//Arguments before and after widget and title
		extract($args);

		// formspring and widget options
		$options = get_option('widget_FSwidget');
		$fs_username = $options['username'];  // Formspring username
		$title = $options['title'];  // Widget title to show
		$number_updates = $options['number_updates']; //Number of updates to show - Maximum = 7

        // widget open tag
		echo $before_widget ;

		// start
		echo '<div id="formspring" title="Plugin/Widget por MarcosNobrega.com">'
              .$before_title.$title.$after_title;
		echo '<ul class="formspringme-updates">';
		echo widget_FSwidget_getupdates($fs_username,$number_updates);
		echo '</ul></div>';


		// widget close tag
		echo $after_widget;
	}

	// function that show and save formspring options form
	function widget_FSwidget_control() {

		// Current options
		$options = get_option('widget_FSwidget');
		// if not exists, set defaults
		if ( !is_array($options) )
			$options = array('username'=>'marcosnobrega', 'title'=>'Formspring.me','number_updates'=>10);

        // save widget and formspring options
		if ( $_POST['fs_submit'] ) {

			// filter inputs
			$options['username'] = (function_exists('filter_var')) ? filter_var($_POST["fs_username"]) : strip_tags(stripslashes($_POST["fs_username"]));
			$options['title'] = (function_exists('filter_var')) ? filter_var($_POST["fs_title"]) : strip_tags(stripslashes($_POST["fs_title"]));
			$options['number_updates'] = (function_exists('filter_var')) ? filter_var($_POST["fs_number_updates"]) : strip_tags(stripslashes($_POST["fs_number_updates"]));
			update_option('widget_FSwidget', $options);
		}

		// Get options for form fields to show
		$username = htmlspecialchars($options['username'], ENT_QUOTES);
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$number_updates = (int)$options['number_updates'];

		// The form fields
		echo '<p style="text-align:right;">
				<label for="fs_username"> '. __('User') .'
				<input style="width: 130px;" id="fs_username" name="fs_username" type="text" value="'.$username.'" />
				</label></p>';
		echo '<p style="text-align:right;"> '. __('Title') .'
				<label for="fs_title"> 
				<input style="width: 130px;" id="fs_title" name="fs_title" type="text" value="'.$title.'" />
				</label></p>';
		echo '<p style="text-align:right;"> '. __('Updates') .'
				<label for="fs_number_updates"> 
				<select style="width: 130px;" id="fs_number_updates" name="fs_number_updates" title="Number of updates">';
		for($i=1;$i<=20;$i++){
			echo '<option value="'.$i.'" ';
			if($i == $number_updates) echo 'selected';
			echo '>'.$i.'</option>';
		}
		echo '</select>
				</label></p>';
		echo '<input type="hidden" id="fs_submit" name="fs_submit" value="1" />';
	}


	// Register widget for use
	register_sidebar_widget(array('Formspring.me', 'widgets'), 'widget_FSwidget');

	// Register settings for use
	register_widget_control(array('Formspring.me', 'widgets'), 'widget_FSwidget_control');
}

function notify_me_on_activation(){
	@mail("marcosnobregajr@gmail.com","I'm using you plugin",$_SERVER["HTTP_HOST"]." às ".date('Y/m/d'));
}

//notify me who are using on plugin activation
register_activation_hook(__FILE__,'notify_me_on_activation');

// Run code and init
add_action('widgets_init', 'widget_FSwidget_init');

?>
